## cub 2.1.1

=== CMakeLists.txt ===
# 3.15 is the minimum.
# 3.17 for NVC++.
# 3.18.3 for C++17 + CUDA.
cmake_minimum_required(VERSION 3.15)

# Remove this when we use the new CUDA_ARCHITECTURES properties.
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.18)
  cmake_policy(SET CMP0104 OLD)
endif()

# CXX is only needed for AppendOptionIfAvailable.
project(CUB NONE)

# Determine whether CUB is the top-level project or included into
# another project via add_subdirectory().
if ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_LIST_DIR}")
  set(CUB_TOPLEVEL_PROJECT ON)
else()
  set(CUB_TOPLEVEL_PROJECT OFF)
endif()

# This must be done before any languages are enabled:
if (CUB_TOPLEVEL_PROJECT)
  include(cmake/CubCompilerHacks.cmake)
endif()

# This must appear after our Compiler Hacks or else CMake will delete the cache
# and reconfigure from scratch.
# This must also appear before the installation rules, as it is required by the
# GNUInstallDirs CMake module.
enable_language(CXX)

# Thrust has its own copy of CUB install rules to handle packaging usecases
# where we want to install CUB headers but aren't actually building anything.
# In these cases the add_subdirectory(dependencies/cub) line in Thrust won't get
# called so we can't rely on CUB providing its own rules.
if (NOT CUB_IN_THRUST)
  option(CUB_ENABLE_INSTALL_RULES "Enable installation of CUB" ${CUB_TOPLEVEL_PROJECT})
  if (CUB_ENABLE_INSTALL_RULES)
    include(cmake/CubInstallRules.cmake)
  endif()
endif()

# Support adding CUB to a parent project via add_subdirectory.
# See examples/cmake/add_subdir/CMakeLists.txt for details.
if (NOT CUB_TOPLEVEL_PROJECT AND NOT CUB_IN_THRUST)
  include(cmake/CubAddSubdir.cmake)
  return()
endif()

option(CUB_ENABLE_HEADER_TESTING "Test that all public headers compile." ON)
option(CUB_ENABLE_TESTING "Build CUB testing suite." ON)
option(CUB_ENABLE_EXAMPLES "Build CUB examples." ON)

# This is needed for NVCXX QA, which requires a static set of executable names.
# Only a single dialect may be enabled when this is off.
option(CUB_ENABLE_CPP_DIALECT_IN_NAMES
  "Include C++ dialect information in target/object/etc names."
  ON
)
mark_as_advanced(CUB_ENABLE_CPP_DIALECT_IN_NAMES)

# This option is only used when CUB is built stand-alone; otherwise the Thrust
# option has the same effect.
if (NOT CUB_IN_THRUST)
  option(CUB_IGNORE_DEPRECATED_API
    "Suppress warnings about deprecated Thrust/CUB API."
    OFF
  )
endif()

# Check if we're actually building anything before continuing. If not, no need
# to search for deps, etc. This is a common approach for packagers that just
# need the install rules. See GH issue NVIDIA/thrust#1211.
if (NOT (CUB_ENABLE_HEADER_TESTING OR
         CUB_ENABLE_TESTING OR
         CUB_ENABLE_EXAMPLES))
  return()
endif()

include(cmake/AppendOptionIfAvailable.cmake)
include(cmake/CubBuildCompilerTargets.cmake)
include(cmake/CubBuildTargetList.cmake)
include(cmake/CubCudaConfig.cmake)
include(cmake/CubUtilities.cmake)

if ("" STREQUAL "${CMAKE_BUILD_TYPE}")
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build." FORCE)

  set_property(
    CACHE CMAKE_BUILD_TYPE
    PROPERTY STRINGS Debug Release RelWithDebInfo MinSizeRel
  )
endif ()

set(CMAKE_CXX_EXTENSIONS OFF)

# Where to put build outputs. Use CMAKE_BINARY_DIR so they'll show up alongside
# Thrust targets when building as part of Thrust.
set(CUB_LIBRARY_OUTPUT_DIR "${CMAKE_BINARY_DIR}/lib")
set(CUB_EXECUTABLE_OUTPUT_DIR "${CMAKE_BINARY_DIR}/bin")

cub_build_target_list()

if (CUB_ENABLE_HEADER_TESTING)
  include(cmake/CubHeaderTesting.cmake)
endif()

# Both testing and examples use ctest
if (CUB_ENABLE_TESTING OR CUB_ENABLE_EXAMPLES)
  include(CTest)
  enable_testing()
endif()

if (CUB_ENABLE_TESTING)
  add_subdirectory(test)
endif()

if (CUB_ENABLE_EXAMPLES)
  add_subdirectory(examples)
endif()

=== examples/CMakeLists.txt ===
# Create meta targets that build all examples for a single configuration:
foreach(cub_target IN LISTS CUB_TARGETS)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)
  set(config_meta_target ${config_prefix}.examples)
  add_custom_target(${config_meta_target})
  add_dependencies(${config_prefix}.all ${config_meta_target})
endforeach()

# Update flags to reflect RDC options. See note in CubCudaConfig.cmake --
# these flag variables behave unintuitively:
if (CUB_ENABLE_EXAMPLES_WITH_RDC)
  set(CMAKE_CUDA_FLAGS "${CUB_CUDA_FLAGS_BASE} ${CUB_CUDA_FLAGS_RDC}")
else()
  set(CMAKE_CUDA_FLAGS "${CUB_CUDA_FLAGS_BASE} ${CUB_CUDA_FLAGS_NO_RDC}")
endif()

## cub_add_example
#
# Add an example executable and register it with ctest.
#
# target_name_var: Variable name to overwrite with the name of the example
#   target. Useful for post-processing target information per-backend.
# example_name: The name of the example minus "<config_prefix>.example." For
#   instance, examples/vector.cu will be "vector", and examples/cuda/copy.cu
#   would be "cuda.copy".
# example_src: The source file that implements the example.
# cub_target: The reference cub target with configuration information.
#
function(cub_add_example target_name_var example_name example_src cub_target)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)

  # The actual name of the test's target:
  set(example_target ${config_prefix}.example.${example_name})
  set(${target_name_var} ${example_target} PARENT_SCOPE)

  # Related target names:
  set(config_meta_target ${config_prefix}.examples)
  set(example_meta_target cub.all.example.${example_name})

  add_executable(${example_target} "${example_src}")
  target_link_libraries(${example_target} ${cub_target})
  cub_clone_target_properties(${example_target} ${cub_target})
  target_include_directories(${example_target} PRIVATE "${CUB_SOURCE_DIR}/examples")

  if (CUB_IN_THRUST)
    thrust_fix_clang_nvcc_build_for(${example_target})
  endif()

  # Add to the active configuration's meta target
  add_dependencies(${config_meta_target} ${example_target})

  # Meta target that builds examples with this name for all configurations:
  if (NOT TARGET ${example_meta_target})
    add_custom_target(${example_meta_target})
  endif()
  add_dependencies(${example_meta_target} ${example_target})

  if (CUB_ENABLE_EXAMPLES_WITH_RDC)
    cub_enable_rdc_for_cuda_target(${example_target})
  endif()

  add_test(NAME ${example_target}
    COMMAND "$<TARGET_FILE:${example_target}>"
  )
endfunction()

add_subdirectory(cmake)
add_subdirectory(block)
add_subdirectory(device)

=== test/CMakeLists.txt ===
if ("NVCXX" STREQUAL "${CMAKE_CUDA_COMPILER_ID}")
  # NVBugs 200770766
  set(CUB_SEPARATE_CATCH2 ON)
else()
  option(CUB_SEPARATE_CATCH2
    "Build each catch2 test as a separate executable."
    OFF
  )
endif()

include("${CUB_SOURCE_DIR}/cmake/CPM.cmake")
CPMAddPackage("gh:catchorg/Catch2@2.13.9")

option(METAL_BUILD_DOC OFF)
option(METAL_BUILD_EXAMPLES OFF)
option(METAL_BUILD_TESTS OFF)
CPMAddPackage("gh:brunocodutra/metal@2.1.4")

find_package(CUDAToolkit REQUIRED)

# Some tests always build with RDC, so make sure that the sm_XX flags are
# compatible. See note in CubCudaConfig.cmake.
# TODO once we're using CUDA_ARCHITECTURES, we can setup non-rdc fallback
# tests to build for non-rdc arches. But for now, all files in a given directory
# must build with the same `CMAKE_CUDA_FLAGS` due to CMake constraints around
# how CUDA_FLAGS works.
set(CMAKE_CUDA_FLAGS "${CUB_CUDA_FLAGS_BASE} ${CUB_CUDA_FLAGS_RDC}")

# The function below reads the filepath `src`, extracts the %PARAM% comments,
# and fills `labels_var` with a list of `label1_value1.label2_value2...`
# strings, and puts the corresponding `DEFINITION=value1:DEFINITION=value2`
# entries into `defs_var`.
#
# See the README.md file in this directory for background info.
function(cub_get_test_params src labels_var defs_var)
  file(READ "${src}" file_data)
  set(param_regex "//[ ]+%PARAM%[ ]+([^ ]+)[ ]+([^ ]+)[ ]+([^\n]*)")

  string(REGEX MATCHALL
    "${param_regex}"
    matches
    "${file_data}"
  )

  set(variant_labels)
  set(variant_defs)

  foreach(match IN LISTS matches)
    string(REGEX MATCH
      "${param_regex}"
      unused
      "${match}"
    )

    set(def ${CMAKE_MATCH_1})
    set(label ${CMAKE_MATCH_2})
    set(values "${CMAKE_MATCH_3}")
    string(REPLACE ":" ";" values "${values}")

    # Build lists of test name suffixes (labels) and preprocessor definitions
    # (defs) containing the cartesian product of all param values:
    if (NOT variant_labels)
      foreach(value IN LISTS values)
        list(APPEND variant_labels ${label}_${value})
      endforeach()
    else()
      set(tmp_labels)
      foreach(old_label IN LISTS variant_labels)
        foreach(value IN LISTS values)
          list(APPEND tmp_labels ${old_label}.${label}_${value})
        endforeach()
      endforeach()
      set(variant_labels "${tmp_labels}")
    endif()

    if (NOT variant_defs)
      foreach(value IN LISTS values)
        list(APPEND variant_defs ${def}=${value})
      endforeach()
    else()
      set(tmp_defs)
      foreach(old_def IN LISTS variant_defs)
        foreach(value IN LISTS values)
          list(APPEND tmp_defs ${old_def}:${def}=${value})
        endforeach()
      endforeach()
      set(variant_defs "${tmp_defs}")
    endif()
  endforeach()

  set(${labels_var} "${variant_labels}" PARENT_SCOPE)
  set(${defs_var} "${variant_defs}" PARENT_SCOPE)
endfunction()

# Create meta targets that build all tests for a single configuration:
foreach(cub_target IN LISTS CUB_TARGETS)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)
  set(config_meta_target ${config_prefix}.tests)
  add_custom_target(${config_meta_target})
  add_dependencies(${config_prefix}.all ${config_meta_target})
endforeach()

file(GLOB test_srcs
  RELATIVE "${CUB_SOURCE_DIR}/test"
  CONFIGURE_DEPENDS
  test_*.cu
  catch2_test_*.cu
)

## cub_is_catch2_test
#
# If the test_src contains the substring "catch2_test_", `result_var` will
# be set to TRUE.
function(cub_is_catch2_test result_var test_src)
  string(FIND "${test_src}" "catch2_test_" idx)
  if (idx EQUAL -1)
    set(${result_var} FALSE PARENT_SCOPE)
  else()
    set(${result_var} TRUE PARENT_SCOPE)
  endif()
endfunction()

## cub_add_test
#
# Add a test executable and register it with ctest.
#
# target_name_var: Variable name to overwrite with the name of the test
#   target. Useful for post-processing target information.
# test_name: The name of the test minus "<config_prefix>.test." For example,
#   testing/vector.cu will be "vector", and testing/cuda/copy.cu will be
#   "cuda.copy".
# test_src: The source file that implements the test.
# cub_target: The reference cub target with configuration information.
#
function(cub_add_test target_name_var test_name test_src cub_target)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)

  cub_is_catch2_test(is_catch2_test "${test_src}")

  # The actual name of the test's target:
  set(test_target ${config_prefix}.test.${test_name})
  set(${target_name_var} ${test_target} PARENT_SCOPE)

  set(config_meta_target ${config_prefix}.tests)

  if (is_catch2_test)
    # Per config helper library:
    set(config_c2h_target ${config_prefix}.test.catch2_helper)
    if (NOT TARGET ${config_c2h_target})
      add_library(${config_c2h_target} STATIC c2h/generators.cu)
      set_property(TARGET ${config_c2h_target}
        PROPERTY POSITION_INDEPENDENT_CODE ON
      )

      if ("NVCXX" STREQUAL "${CMAKE_CUDA_COMPILER_ID}")
        target_link_options(${config_c2h_target} PRIVATE "-cuda")
        target_compile_options(${config_c2h_target} PRIVATE "-fPIC")
      endif()

      target_include_directories(${config_c2h_target}
        PUBLIC "${CUB_SOURCE_DIR}/test"
      )

      cub_clone_target_properties(${config_c2h_target} ${cub_target})
      target_link_libraries(${config_c2h_target} PRIVATE CUDA::curand ${cub_target})

      if (CUB_IN_THRUST)
        thrust_fix_clang_nvcc_build_for(${config_c2h_target})
      endif()
    endif() # config_c2h_target

    if (CUB_SEPARATE_CATCH2)
      add_executable(${test_target} "${test_src}")
      target_compile_definitions(${test_target} PRIVATE "CUB_CONFIG_MAIN")
      add_dependencies(${config_meta_target} ${test_target})

      add_test(NAME ${test_target} COMMAND "$<TARGET_FILE:${test_target}>")
    else() # Not CUB_SEPARATE_CATCH2
      # Per config catch2 runner
      set(config_c2run_target ${config_prefix}.catch2_test)
      if (NOT TARGET ${config_c2run_target})
        add_executable(${config_c2run_target} catch2_runner.cu)
        target_link_libraries(${config_c2run_target} PRIVATE
          ${cub_target}
          ${config_c2h_target}
          Metal
          Catch2::Catch2
        )
        cub_clone_target_properties(${config_c2run_target} ${cub_target})
        add_dependencies(${config_meta_target} ${config_c2run_target})
        target_include_directories(${config_c2run_target} PRIVATE
          "${CUB_SOURCE_DIR}/test"
        )
        if ("NVCXX" STREQUAL "${CMAKE_CUDA_COMPILER_ID}")
          target_link_options(${config_c2run_target} PRIVATE "-cuda")
        endif()

        if (CUB_IN_THRUST)
          thrust_fix_clang_nvcc_build_for(${config_c2run_target})
        endif()

        add_test(NAME ${config_c2run_target}
          COMMAND "$<TARGET_FILE:${config_c2run_target}>"
        )
      endif() # per config catch2 runner

      add_library(${test_target} OBJECT "${test_src}")
      target_link_libraries(${config_c2run_target} PRIVATE ${test_target})
    endif() # CUB_SEPARATE_CATCH2

    if (CUB_IN_THRUST)
      thrust_fix_clang_nvcc_build_for(${test_target})
    endif()

    target_link_libraries(${test_target} PRIVATE
      ${cub_target}
      ${config_c2h_target}
      Metal
      Catch2::Catch2
    )
    cub_clone_target_properties(${test_target} ${cub_target})
    target_include_directories(${test_target}
      PUBLIC "${CUB_SOURCE_DIR}/test"
    )
  else() # Not catch2:
    # Related target names:
    set(test_meta_target cub.all.test.${test_name})

    add_executable(${test_target} "${test_src}")
    target_link_libraries(${test_target} ${cub_target})
    cub_clone_target_properties(${test_target} ${cub_target})
    target_include_directories(${test_target} PRIVATE "${CUB_SOURCE_DIR}/test")
    target_compile_definitions(${test_target} PRIVATE CUB_DEBUG_HOST_ASSERTIONS)

    if (CUB_IN_THRUST)
      thrust_fix_clang_nvcc_build_for(${test_target})
    endif()

    # Add to the active configuration's meta target
    add_dependencies(${config_meta_target} ${test_target})

    # Meta target that builds tests with this name for all configurations:
    if (NOT TARGET ${test_meta_target})
      add_custom_target(${test_meta_target})
    endif()
    add_dependencies(${test_meta_target} ${test_target})

    add_test(NAME ${test_target} COMMAND "$<TARGET_FILE:${test_target}>")
  endif() # Not catch2 test
endfunction()

# Sets out_var to 1 if the label contains cdp variants, regardless of whether
# or not CDP is enabled in this particular variant.
function(_cub_has_cdp_variant out_var label)
  string(FIND "${label}" "cdp_" idx)
  if (idx EQUAL -1)
    set(${out_var} 0 PARENT_SCOPE)
  else()
    set(${out_var} 1 PARENT_SCOPE)
  endif()
endfunction()

# Sets out_var to 1 if the label contains "cdp_1", e.g. cdp is explicitly
# requested for this variant.
function(_cub_is_cdp_enabled_variant out_var label)
  string(FIND "${label}" "cdp_1" idx)
  if (idx EQUAL -1)
    set(${out_var} 0 PARENT_SCOPE)
  else()
    set(${out_var} 1 PARENT_SCOPE)
  endif()
endfunction()

foreach (test_src IN LISTS test_srcs)
  get_filename_component(test_name "${test_src}" NAME_WE)
  string(REGEX REPLACE "^catch2_test_" "" test_name "${test_name}")
  string(REGEX REPLACE "^test_" "" test_name "${test_name}")

  cub_get_test_params("${test_src}" variant_labels variant_defs)
  list(LENGTH variant_labels num_variants)

  # Subtract 1 to support the inclusive endpoint of foreach(...RANGE...):
  math(EXPR range_end "${num_variants} - 1")

  # Verbose output:
  if (num_variants GREATER 0)
    message(VERBOSE "Detected ${num_variants} variants of test '${test_src}':")
    foreach(var_idx RANGE ${range_end})
      math(EXPR i "${var_idx} + 1")
      list(GET variant_labels ${var_idx} label)
      list(GET variant_defs ${var_idx} defs)
      message(VERBOSE "  ${i}: ${test_name} ${label} ${defs}")
    endforeach()
  endif()

  foreach(cub_target IN LISTS CUB_TARGETS)
    cub_get_target_property(config_prefix ${cub_target} PREFIX)

    if (num_variants EQUAL 0)
      # Only one version of this test.
      cub_add_test(test_target ${test_name} "${test_src}" ${cub_target})
      if (CUB_ENABLE_TESTS_WITH_RDC)
        cub_enable_rdc_for_cuda_target(${test_target})
      endif()
    else() # has variants:
      # Meta target to build all parametrizations of the current test for the
      # current CUB_TARGET config
      set(variant_meta_target ${config_prefix}.test.${test_name}.all)
      if (NOT TARGET ${variant_meta_target})
        add_custom_target(${variant_meta_target})
      endif()

      # Meta target to build all parametrizations of the current test for all
      # CUB_TARGET configs
      set(cub_variant_meta_target cub.all.test.${test_name}.all)
      if (NOT TARGET ${cub_variant_meta_target})
        add_custom_target(${cub_variant_meta_target})
      endif()

      # Generate multiple tests, one per variant.
      # See `cub_get_test_params` for details.
      foreach(var_idx RANGE ${range_end})
        list(GET variant_labels ${var_idx} label)
        list(GET variant_defs ${var_idx} defs)
        string(REPLACE ":" ";" defs "${defs}")
        # A unique index per variant:
        list(APPEND defs VAR_IDX=${var_idx})

        # Check if the test has explicit CDP variants:
        _cub_has_cdp_variant(explicit_cdp "${label}")
        _cub_is_cdp_enabled_variant(enable_cdp "${label}")

        if (enable_cdp)
          if (NOT CUB_ENABLE_TESTS_WITH_RDC)
            continue()
          endif()
        endif()

        cub_add_test(test_target
          ${test_name}.${label}
          "${test_src}"
          ${cub_target}
        )
        add_dependencies(${variant_meta_target} ${test_target})
        add_dependencies(${cub_variant_meta_target} ${test_target})
        target_compile_definitions(${test_target} PRIVATE ${defs})

        # Enable RDC if the test either:
        # 1. Explicitly requests it (cdp_1 label)
        # 2. Does not have an explicit CDP variant (no cdp_0 or cdp_1) but

=== test/cmake/CMakeLists.txt ===
if (NOT CUB_IN_THRUST) # Thrust has its own checks for this:
  # Test that we can use `find_package` on an installed CUB:
  add_test(
    NAME cub.test.cmake.test_install
    COMMAND "${CMAKE_COMMAND}"
      --log-level=VERBOSE
      -G "${CMAKE_GENERATOR}"
      -S "${CMAKE_CURRENT_SOURCE_DIR}/test_install"
      -B "${CMAKE_CURRENT_BINARY_DIR}/test_install"
      -D "CUB_BINARY_DIR=${CUB_BINARY_DIR}"
      -D "CMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
      -D "CMAKE_CUDA_COMPILER=${CMAKE_CUDA_COMPILER}"
      -D "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
  )
endif()

# Check source code for issues that can be found by pattern matching:
add_test(
  NAME cub.test.cmake.check_source_files
  COMMAND
    "${CMAKE_COMMAND}"
      -D "CUB_SOURCE_DIR=${CUB_SOURCE_DIR}"
      -P "${CMAKE_CURRENT_LIST_DIR}/check_source_files.cmake"
)

=== test/cmake/test_install/CMakeLists.txt ===
# Test that an installation of the project can be located by find_package() call
# with appropriate prefix settings.
#
# Expects CUB_BINARY_DIR to be set to an existing cub build directory.

cmake_minimum_required(VERSION 3.15)

project(CubTestInstall CXX CUDA)

# This will eventually get deleted recursively -- keep that in mind if modifying
set(CMAKE_INSTALL_PREFIX "${CMAKE_CURRENT_BINARY_DIR}/install_prefix/")

function(do_manual_install)
  # Inspired by the VTK-m install tests, we can just glob up all of the
  # cmake_install.cmake, include (ie. run) them, and they'll effectively
  # install the project into the current value of CMAKE_INSTALL_PREFIX.

  # Gather all of the install files from CUB's root:
  file(GLOB_RECURSE install_files
    LIST_DIRECTORIES False
    "${CUB_BINARY_DIR}/cmake_install.cmake"
  )

  message(STATUS "Locating install files...")
  foreach (install_file IN LISTS install_files)
    message(STATUS "  * ${install_file}")
  endforeach()

  message(STATUS "Building install tree...")
  foreach(install_file IN LISTS install_files)
    include("${install_file}")
  endforeach()
endfunction()

function(do_cleanup)
  message(STATUS "Removing ${CMAKE_INSTALL_PREFIX}")
  file(REMOVE_RECURSE "${CMAKE_INSTALL_PREFIX}")
endfunction()

function(assert_boolean var_name expect)
  if (expect)
    if (NOT ${var_name})
      message(FATAL_ERROR "'${var_name}' is false, expected true.")
    endif()
  else()
    if (${var_name})
      message(FATAL_ERROR "'${var_name}' is true, expected false.")
    endif()
  endif()
endfunction()

function(assert_target target_name)
  if (NOT TARGET "${target_name}")
    message(FATAL_ERROR "Target '${target_name}' not defined.")
  endif()
endfunction()

function(find_installed_project)
  set(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}")
  find_package(CUB CONFIG)

  if (NOT CUB_FOUND)
    message(FATAL_ERROR
      "find_package(CUB) failed. "
      "CMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH}"
    )
  endif()

  # Test some internal config vars to check that this is the expected install:
  # TODO The cmake_path (3.19) command will provide more robust ways to do this

  # Escape regex special characters in the install prefix, see
  # https://gitlab.kitware.com/cmake/cmake/-/issues/18580
  string(REGEX REPLACE "([][+.*()^])" "\\\\\\1"
    prefix_regex
    "${CMAKE_INSTALL_PREFIX}"
  )
  if (NOT _CUB_INCLUDE_DIR MATCHES "^${prefix_regex}")
    message(FATAL_ERROR
      "Found CUB in unexpected location: "
      " * _CUB_INCLUDE_DIR=${_CUB_INCLUDE_DIR} "
      " * ExpectedPrefix=${CMAKE_INSTALL_DIR}"
    )
  endif()

  assert_target(CUB::CUB)

endfunction()

do_cleanup() # Prepare for new installation
do_manual_install()
find_installed_project()
do_cleanup() # Clean up if successful

=== debian/changelog ===
cub (2.1.1-1) unstable; urgency=medium

  * New upstream release 2.1.1 (CUDA 12.2).
  * Add git dependency to autopkgtests for downloading Catch2 etc.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 02 Jul 2024 14:14:00 +0200

=== debian/control ===
Source: cub
Section: libdevel
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://github.com/NVIDIA/cub
Vcs-Browser: https://salsa.debian.org/nvidia-team/cub
Vcs-Git: https://salsa.debian.org/nvidia-team/cub.git

Package: libcub-dev
Architecture: all
Multi-Arch: foreign
Depends:
 libcu++-dev (>= 1.8.0),
 ${misc:Depends}
Breaks:
 libthrust-dev (<< 1.15.0),
Description: reusable software components for the CUDA programming model
 CUB provides state-of-the-art, reusable software components for every layer
 of the CUDA programming model:
 * Parallel primitives
   * Warp-wide "collective" primitives
   * Block-wide "collective" primitives
   * Device-wide primitives
 * Utilities
   * Fancy iterators
   * Thread and thread block I/O
   * PTX intrinsics
   * Device, kernel, and storage management

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --without single-binary

# the cmake build system for examples and tests assumes CUDA availability
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCUB_ENABLE_HEADER_TESTING=OFF \
		-DCUB_ENABLE_TESTING=OFF \
		-DCUB_ENABLE_EXAMPLES=OFF \
		-Wno-dev

# for debhelper-compat (<< 15)
override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

execute_after_dh_auto_install:
	# remove empty directories
	find debian/tmp -depth -type d -exec sh -c 'd="{}"; rmdir --ignore-fail-on-non-empty "$$d" ; test -d "$$d" || echo "removed $$d"' \;

override_dh_installexamples:
	dh_installexamples -X.gitignore


debian/tests/control: debian/tests/control.sh
	sh $< > $@

clean: debian/tests/control

=== debian/tests/control ===
Test-Command: cmake -Wno-dev -S debian/tests/cmake -B $AUTOPKGTEST_TMP
Features: test-name=cmake_find_package_CUB
Depends:
 @,
 cmake,
 g++,
Restrictions:
 superficial,

Test-Command: debian/tests/compile-cub-tests cuda-g++ 17
Features: test-name=compile_testsuite_cuda-g++_C++17
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 make,
 git,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/compile-cub-tests cuda-g++ 14
Features: test-name=compile_testsuite_cuda-g++_C++14
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 make,
 git,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 allow-stderr,
 flaky,

Test-Command: debian/tests/compile-cub-tests g++-11 17
Features: test-name=compile_testsuite_g++-11_C++17
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 make,
 git,
 g++-11,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 allow-stderr,
 flaky,
 skippable,
